import React from 'react';
import type { MovexClient } from 'movex';
import { GetReducerState, GetReducerAction, ResourceIdentifier, MovexClient as MovexClientUser, StringKeys, BaseMovexDefinitionResourcesMap, MovexDefinition } from 'movex-core-util';
type ReactMovexBoundResource<TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends StringKeys<TResourcesMap>> = MovexClient.MovexBoundResource<GetReducerState<TResourcesMap[TResourceType]>, GetReducerAction<TResourcesMap[TResourceType]>>;
type Props<TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends StringKeys<TResourcesMap>> = {
    movexDefinition: MovexDefinition<TResourcesMap>;
    rid: ResourceIdentifier<TResourceType>;
    onReady?: (p: {
        boundResource: ReactMovexBoundResource<TResourcesMap, TResourceType>;
        clientId: MovexClientUser['id'];
    }) => void;
    onComponentWillUnmount?: (p: State<TResourcesMap, TResourceType>) => void;
    onResourceStateUpdated?: (p: ReactMovexBoundResource<TResourcesMap, TResourceType>['state']) => void;
    render: (p: {
        boundResource: ReactMovexBoundResource<TResourcesMap, TResourceType>;
        clientId: MovexClientUser['id'];
    }) => React.ReactNode;
    fallback?: React.ReactNode;
};
type State<TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends StringKeys<TResourcesMap>> = {
    init: false;
} | {
    init: true;
    boundResource: ReactMovexBoundResource<TResourcesMap, TResourceType>;
    clientId: MovexClientUser['id'];
};
export declare class MovexBoundResourceComponent<TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends StringKeys<TResourcesMap>> extends React.Component<Props<TResourcesMap, TResourceType>, State<TResourcesMap, TResourceType>> {
    private unsubscribers;
    constructor(props: Props<TResourcesMap, TResourceType>);
    componentDidUpdate(prevProps: Readonly<Props<TResourcesMap, TResourceType>>, prevState: Readonly<State<TResourcesMap, TResourceType>>): void;
    private init;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
export {};
