/// <reference types="react" />
import type { BaseMovexDefinitionResourcesMap, MovexDefinition, ResourceIdentifier, SanitizedMovexClient, StringKeys, UnsubscribeFn } from 'movex-core-util';
import type { MovexClient, Movex } from 'movex';
export type MovexContextProps<TResourcesMap extends BaseMovexDefinitionResourcesMap> = MovexContextPropsNotConnected | MovexContextPropsConnected<TResourcesMap>;
export type MovexContextPropsNotConnected = {
    status: 'disconnected' | 'initiating' | 'connectionError';
    client?: undefined;
    movex?: Movex;
    movexConfig?: undefined;
    bindResource?: () => void;
};
export type MovexContextPropsConnected<TResourcesMap extends BaseMovexDefinitionResourcesMap> = {
    status: 'connected';
    client: SanitizedMovexClient;
    movex: MovexClient.MovexFromDefinition<TResourcesMap>;
    movexDefinition: MovexDefinition<TResourcesMap>;
    bindResource: <TResourceType extends StringKeys<TResourcesMap>>(rid: ResourceIdentifier<TResourceType>, onStateUpdate: (p: MovexClient.MovexBoundResource) => void) => UnsubscribeFn;
};
export declare const initialMovexContext: {
    readonly movex: undefined;
    readonly status: "initiating";
};
export declare const MovexContext: import("react").Context<MovexContextProps<BaseMovexDefinitionResourcesMap>>;
