import React from 'react';
import { MovexContextProps } from './MovexContext';
import { type BaseMovexDefinitionResourcesMap, type MovexDefinition, type SanitizedMovexClient, MovexLogger } from 'movex-core-util';
export type MovexProviderProps<TMovexConfigResourcesMap extends BaseMovexDefinitionResourcesMap> = React.PropsWithChildren<{
    /**
     * The definition or movex.config file
     */
    movexDefinition: MovexDefinition<TMovexConfigResourcesMap>;
    /**
     * The Movex Master Instance URL
     */
    endpointUrl: string;
    /**
     * An optional Id for the client. Most often the userId in your own application userbase
     */
    clientId?: SanitizedMovexClient['id'];
    /**
     * This will be shared among all the peers in Movex, so make sure it's sanitized!
     */
    clientInfo?: SanitizedMovexClient['info'];
    /**
     * Optional Event Logger
     */
    logger?: MovexLogger;
    onConnectionStatusChange?: (state: MovexContextProps<TMovexConfigResourcesMap>) => void;
}>;
export declare const MovexProvider: React.FC<MovexProviderProps<BaseMovexDefinitionResourcesMap>>;
