import type { ResourceIdentifier, GetReducerAction, GetReducerState, BaseMovexDefinitionResourcesMap, MovexDefinition, SanitizedMovexClient } from 'movex-core-util';
import { MovexClient as MovexClientUser } from 'movex-core-util';
import { MovexClient } from 'movex';
import { MovexContextProps } from './MovexContext';
export declare const useMovex: <TResourcesMap extends BaseMovexDefinitionResourcesMap>(movexConfig: MovexDefinition<TResourcesMap>) => MovexContextProps<TResourcesMap>;
export declare const useMovexClient: (movexConfig?: MovexDefinition<BaseMovexDefinitionResourcesMap>) => SanitizedMovexClient | undefined;
export type MovexResourceFromConfig<TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends keyof TResourcesMap, Reducer extends MovexDefinition<TResourcesMap>['resources'][TResourceType] = MovexDefinition<TResourcesMap>['resources'][TResourceType]> = MovexClient.MovexResource<GetReducerState<Reducer>, GetReducerAction<Reducer>, string>;
export type MovexBoundResourceFromConfig<TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends Extract<keyof TResourcesMap, string>, Reducer extends MovexDefinition<TResourcesMap>['resources'][TResourceType] = MovexDefinition<TResourcesMap>['resources'][TResourceType]> = MovexClient.MovexBoundResource<GetReducerState<Reducer>, GetReducerAction<Reducer>>;
export declare const useMovexResourceType: <TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends Extract<keyof TResourcesMap, string>>(movexConfig: MovexDefinition<TResourcesMap>, resourceType: TResourceType) => MovexResourceFromConfig<TResourcesMap, TResourceType, TResourcesMap[TResourceType]> | undefined;
export declare const useMovexBoundResourceFromRid: <TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends Extract<keyof TResourcesMap, string>>(movexDefinition: MovexDefinition<TResourcesMap>, rid: ResourceIdentifier<TResourceType>, handlers?: {
    onReady?: ((p: {
        boundResource: MovexClient.MovexBoundResource<ReturnType<TResourcesMap[TResourceType]>, GetReducerAction<TResourcesMap[TResourceType], any>>;
        clientId: MovexClientUser['id'];
    }) => void) | undefined;
} | undefined) => MovexBoundResourceFromConfig<TResourcesMap, TResourceType, TResourcesMap[TResourceType]> | undefined;
export declare const createMovexResource: <TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends Extract<keyof TResourcesMap, string>>(movex: MovexClient.MovexFromDefinition<TResourcesMap>, res: {
    type: TResourceType;
    state: ReturnType<TResourcesMap[TResourceType]>;
}) => import("ts-async-results").AsyncResultWrapper<{
    rid: import("movex-core-util").ResourceIdentifierObj<TResourceType>;
    state: ReturnType<TResourcesMap[TResourceType]>;
    subscribers: Record<string, SanitizedMovexClient<import("movex-core-util").UnknownRecord>>;
}, unknown>;
export declare const useCreateMovexResourceOnDemand: <TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends Extract<keyof TResourcesMap, string>>(movexConfig: MovexDefinition<TResourcesMap>, resourceInit: {
    type: TResourceType;
    state: ReturnType<TResourcesMap[TResourceType]>;
} | undefined, onCreated: (rid: ResourceIdentifier<TResourceType>) => void) => void;
export declare const useMovexBindOrCreateAndBindOnDemand: <TResourcesMap extends BaseMovexDefinitionResourcesMap, TResourceType extends Extract<keyof TResourcesMap, string>>(movexConfig: MovexDefinition<TResourcesMap>, resourceInitOrRid: {
    type: TResourceType;
    state: ReturnType<TResourcesMap[TResourceType]>;
} | ResourceIdentifier<TResourceType> | undefined) => MovexClient.MovexBoundResource<ReturnType<TResourcesMap[TResourceType]>, GetReducerAction<TResourcesMap[TResourceType], any>> | undefined;
